<?php  
  /* 
    Plugin Name: WP Secure Links 
    Plugin URI: http://www.sixthlife.net 
    Description: WP Secure Links Plugin can be used to create secure download links. Select the page at <a href="../options-general.php?page=secdown/sdldownload.php">WP Secure Links</a> where user should be redirected for invalid download attempts. 
    Author: Sixthlife
    Version: 1.0 
    Author URI: http://www.sixthlife.net 
    */  
    

include_once(dirname(__FILE__).DIRECTORY_SEPARATOR."sdlfunct.php");                      //including functions.php

add_action('init', 'sdl_download');


function sdl_download(){ 
				                                      //database connection
startover();                                    // Delete records older that no of days defined in settings file.
if((isset($_GET['dc']))&& (!empty($_GET['dc']))){   // Check if download code is set

    if(authenticate($_GET['dc'])){                    //Verify if download code is correct.
	$filename = getfile($_GET['dc']);           
    $fakename = fakefilename($_GET['dc']);
    $extension = fileexten($filename);

        if(($filename!= false)&&($fakename!=false&& @fopen($filename,'r')==true)){
        $mime = contenttype($extension);
        set_time_limit(0);
        header('Pragma: public');
        header('Expires: 0'); 
        header("Content-Type:".$mime);
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Content-Disposition: attachment;filename='.$fakename.'.'.$extension);
        header("Content-Transfer-Encoding: binary");
        //ob_clean();
        flush();
        @readfile($filename);
        }
        else{
    	$error ="<h3>We could not find this file</h3>";} // If the filename or fake filename could not be retrieved. 
        }  
    else{
    	$error =   "<h3>The download link is not correct.</h3>";             // If the download code  is not correct. 
    }
}
else{   
  								               // If the download code  is not set or empty. 
    }  

if(isset($error)){                              //show no permissions page.  
 $no_accesspage = get_option( 'noaccesspage', false );

header('location:'.get_permalink( $no_accesspage ));
exit;	
}

}


function sdl_scripts_general() {
    wp_enqueue_script('secodwn',plugins_url('/js/general.js', __FILE__), array('jquery'));
}
add_action('wp_enqueue_scripts', 'sdl_scripts_general');

//wp_enqueue_script('secodwn', plugins_url('/js/general.js', __FILE__), array('jquery'));
function downloadlink($atts, $anchortext){

   extract( shortcode_atts( array(
   	  'url' => '',
      'name' => 'download',
      'class' => '',
      'id' => '',
      'title' => ''
      ), $atts ) );

	 $pluginpath = plugin_dir_url( 'setreferer.php' ).plugin_basename(__FILE__);
	 $pluginpath = explode('/',$pluginpath );
	 array_pop($pluginpath);
	 $pluginpath = implode('/',$pluginpath);
	 $pluginpath =$pluginpath;
	 if(isset($name) && $name==""){ $name = 'download';}
	 $link = '<a href="'.downloadurl(trim($url),$name).'" ';
	 
	 if(isset($id) && $id != ''){ 	 	
	 	$link .= 'id="'.$id.'" ';
	 }
	 if(isset($title) && $title != ''){ 	
	 	$link .= 'title="'.$title.'" ';
	 }	 
	 if(isset($class) && $class != ''){ 	
	 	$link .= 'class="'.$class.'" ';
	 }
	 $link .=' onclick="javascript:updateReferer(this,\''.$pluginpath.'\');" >'.$anchortext.'</a>';

return $link;	 

}

add_shortcode( 'slink', 'downloadlink' );

// create custom plugin settings menu
add_action('admin_menu', 'sdl_create_menu');

function sdl_create_menu() {

	//create new top-level menu
	add_options_page('WP Secure Links', 'WP Secure Links', 'administrator', __FILE__, 'sdl_settings_page',plugins_url('/images/icon.png', __FILE__));

	//call register settings function
	add_action( 'admin_init', 'register_sdlsettings' );
}


function register_sdlsettings() {
	//register our settings
	register_setting( 'sdl-settings-group', 'nooffiles' );
	register_setting( 'sdl-settings-group', 'startover' );
	register_setting( 'sdl-settings-group', 'noaccesspage' );

}

function sdl_settings_page() {
$args = array(
    'post_type' => 'page',
	'name' => 'noaccesspage',
	'show_option_none' => 'Select Page',
	'selected' => get_option('noaccesspage')
	);
?><div class="wrap">
<div id="icon-link-manager" class="icon32" ></div>
<h2>WP Secure Links</h2>

<form method="post" action="options.php" ><?php settings_fields( 'sdl-settings-group' ); ?><table class="form-table">
<tbody>     
        <tr valign="top">
		
		<th scope="row"><label for="">Number of Files</th> <td>
        <input type="text" class="regular-text" name="nooffiles" value="<?php if(get_option('nooffiles')==""){ echo 10000;} else{  echo get_option('nooffiles');} ?>" />
        <p class="description">Expected Number of downloadable Files. Default Value is 10,000. </p>
       </td>
         </tr>
		 <tr valign="top">
        <th  scope="row"><label for="">
  Start Over</label></th><td>
        <input type="text" class="regular-text" name="startover" value="<?php if(get_option('startover')==""){ echo 30;} else{  echo get_option('startover');} ?>" />
        <p class="description">Number of days after which unusable data from database is flushed or removed. Default value is 30. </p>
               </td></tr>
      		 <tr valign="top">
        <th  scope="row"><label for="">
   Unauthorized Access Page</label></th><td>
<?php wp_dropdown_pages( $args ); ?> 
        <p class="description">No Permissions page for Unauthorized Access to Downloadable Files.  </p>
               </td></tr>     
</tbody>
</table><?php submit_button(); ?></form>
</div>
<?php } ?><?php 

// Add buttons to html editor
add_action('admin_print_footer_scripts','eg_quicktags');
function eg_quicktags() {
 ?>
<script type="text/javascript" charset="utf-8">
if ( typeof(QTags) == 'function' ) { 
QTags.addButton( 'eg_slink', 'slink', '[slink url=""]', '[/slink]', 'slink', 'Secure Link' );
}

</script>
<?php } ?><?php 
global $sdl_db_version;
$sdl_db_version = "1.0";

function sdl_install(){
global $wpdb;
global $sdl_db_version;	

createdbtables();
require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
add_option("sdl_db_version", $sdl_db_version);	
}

register_activation_hook(__FILE__, 'sdl_install');

function sdl_on_deactivate() {
global $wpdb;
$sql = "DROP TABLE  {$wpdb->prefix}ddown";
$sql1 = "DROP TABLE  {$wpdb->prefix}ipmap";

require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
$wpdb->query($sql);
$wpdb->query($sql1);
}
register_deactivation_hook(__FILE__, 'sdl_on_deactivate');
?>